//FormatAnpassen_502d.js
// 24.05.10 / Hans Haesler, Chtelard 52, CH-1018 Lausanne
//ndert das gewhlte Absatz- oder Zeichenformat entsprechend der Auswahl

// vorbeugenderweise das Anzeigen von Dialogen aktivieren
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

if (app.documents.length == 0) {
	alert ("Es ist kein Dokument offen.", "Achtung");
	exit();
}

// die Auswahl prfen
try {
	var curType = app.selection[0].constructor.name;
	if (curType != "InsertionPoint" && curType != "Character" && curType != "Text" && curType != "Word" 
		&& curType != "Line" && curType != "Paragraph" && curType != "TextColumn" && curType != "TextStyleRange") {
		alert ("Bitte den Mustertext auswhlen.", "Achtung");
		exit ();
	}
}
catch (e) {
	alert ("Es ist nichts ausgewhlt.", "Achtung");
	exit();
}

// prfen, ob Absatzformat-Gruppen bestehen
paraGroups = app.documents[0].paragraphStyleGroups;
var nPSG = paraGroups.length;

// prfen, ob Zeichenformat-Gruppen bestehen
charGroups = app.documents[0].characterStyleGroups;
var nCSG = charGroups.length;

//--- die Liste der Absatzformatnamen aufstellen ---//
if (nPSG == 0) {
	var dlogPStyles = app.documents[0].paragraphStyles.everyItem().name;
	// das erste Element durch ein leeres Element ersetzen
	dlogPStyles[0] = "";
	nDlogPStyles = dlogPStyles.length;
}
else {
	pGroupNames = paraGroups.everyItem().name;
	pGroupNames = ["[Root]"].concat(pGroupNames);
	var curName;
	var dlogPStyles = app.documents[0].paragraphStyles.everyItem().name;
	// bei jedem Element drei Leerrume einfgen
	for (var i=0; i<dlogPStyles.length; i++) {
		curName = "   " + dlogPStyles[i];
		dlogPStyles[i] = curName;
	}
	// das erste Element durch "[Root]" ersetzen
	dlogPStyles[0] = "[Root]";
	// zu Beginn ein leeres Element einfgen
	dlogPStyles = [""].concat(dlogPStyles);
	var curGroup;
	var curParaStyles;
	// eine Schleife durch die Gruppen
	for (var i=0; i<nPSG; i++) {
		curGroup = paraGroups[i];
		curParaStyles = curGroup.paragraphStyles.everyItem().name;
		// bei jedem Element drei Leerrume einfgen
		for (var k=0; k<curParaStyles.length; k++) {
			curName = "   " + curParaStyles[k];
			curParaStyles[k] = curName;
		}
		// ein Element mit dem Namen der Gruppe voranstellen
		curParaStyles = [curGroup.name].concat(curParaStyles);
		dlogPStyles = dlogPStyles.concat(curParaStyles);
	}
	nDlogPStyles = dlogPStyles.length;
	// die Positionen der Gruppennamen feststellen
	var pGroupIDs = new Array ();
	pGroupIDs.push(0);
	for (var i=2; i<nDlogPStyles; i++) {
		if (dlogPStyles[i][0] != " ") {
			pGroupIDs.push(i);
		}
	}
	// die Reihenfolge der Liste umkehren
	pGroupIDs.reverse();
}

//--- die Liste der Zeichenformatnamen aufstellen ---//
if (nCSG == 0) {
	var dlogCStyles = app.documents[0].characterStyles.everyItem().name;
	// das erste Element durch ein leeres Element ersetzen
	dlogCStyles[0] = "";
		nDlogCStyles = dlogCStyles.length;
}
else {
	cGroupNames = charGroups.everyItem().name;
	cGroupNames = ["[Root]"].concat(cGroupNames);
	var dlogCStyles = app.documents[0].characterStyles.everyItem().name;
	// bei jedem Element drei Leerrume einfgen
	for (var i=0; i<dlogCStyles.length; i++) {
		curName = "   " + dlogCStyles[i];
		dlogCStyles[i] = curName;
	}
	// das erste Element durch "[Root]" ersetzen
	dlogCStyles[0] = "[Root]";
	// zu Beginn ein leeres Element einfgen
	dlogCStyles = [""].concat(dlogCStyles);
	// eine Schleife durch die Gruppen
	var curGroup;
	var curCharStyles;
	for (var i=0; i<nCSG; i++) {
		curGroup = charGroups[i];
		curCharStyles = curGroup.characterStyles.everyItem().name;
		// bei jedem Element drei Leerrume einfgen
		for (var k=0; k<curCharStyles.length; k++) {
			curName = "   " + curCharStyles[k];
			curCharStyles[k] = curName;
		}
		// ein Element mit dem Namen der Gruppe voranstellen
		curCharStyles = [curGroup.name].concat(curCharStyles);
		dlogCStyles = dlogCStyles.concat(curCharStyles);
	}
	nDlogCStyles = dlogCStyles.length;
	// die Positionen der Gruppennamen feststellen
	var cGroupIDs = new Array ();
	cGroupIDs.push(0);
	for (var i=2; i<nDlogCStyles; i++) {
		if (dlogCStyles[i][0] != " ") {
			cGroupIDs.push(i);
		}
	}
	// die Reihenfolge der Liste umkehren
	cGroupIDs.reverse();
}

// Dialoge, welche eventuell im Speicher geblieben sind, lschen
try {
	app.dialogs.everyItem().destroy();
}
catch (e) {
}

// vorbeugenderweise das Anzeigen von Dialogen aktivieren
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// einen Dialog vorbereiten
var aDialog = app.dialogs.add({name:"Das zu ndernde Format whlen", canCancel:true});
with (aDialog) {
	with (dialogColumns.add()) {
		with (dialogRows.add()) {
			staticTexts.add({staticLabel:"Absatzformate:"});
			staticTexts.add({staticLabel:" "});
		}
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				var paraName = dropdowns.add({stringList:dlogPStyles, selectedIndex:0, minWidth:180});
			}
		}
		with (dialogRows.add()) {
			staticTexts.add({staticLabel:"Zeichenformate:"});
			staticTexts.add({staticLabel:" "});
		}
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				var charName = dropdowns.add({stringList:dlogCStyles, selectedIndex:0, minWidth:180});
			}
		}
	}
	with (dialogColumns.add()) {
		staticTexts.add({staticLabel:"", minWidth:4});
	}
}
// den Dialog zeigen
if (aDialog.show() == true) {
	// die Wahl des Anwenders bernehmen
	var paraID = paraName.selectedIndex;
	var charID = charName.selectedIndex;
	// den Dialog aus dem Speicher entfernen
	aDialog.destroy();
}
else {
	aDialog.destroy();
	exit();
}

// die Wahl des Anwenders testen
if (nPSG != 0) {
	if (paraID != 0) {
		var testString = dlogPStyles[paraID].slice(0,3);
		if (testString != "   ") {
			alert ("Nicht den Namen einer Gruppe auswhlen!", "Stop");
			exit();
		}
	}
}
if (nCSG != 0) {
	if (charID != 0) {
		var testString = dlogCStyles[charID].slice(0,3);
		if (testString != "   ") {
			alert ("Nicht den Namen einer Gruppe auswhlen!", "Stop");
			exit();
		}
	}
}

// die Attribute der Auswahl speichern
var newProps = app.selection[0].properties;

// das entsprechende Format ndern
if (paraID != 0) {
	// den Formatnamen speichern
	var curPara = dlogPStyles[paraID];
	// wenn keine Absatzformatgruppen vorhanden sind
	if (nPSG == 0) {
		//curPara = dlogPStyles[paraID];
		app.documents[0].paragraphStyles.item(curPara).properties = newProps;
	}
	// sonst muss vorgngig die Gruppe festgestellt werden
	else {
		grpName = undefined;
		// die drei Leerrume entfernen
		curPara = curPara.slice(3);
		// die Liste der Gruppennamen umkehren
		pGroupNames.reverse();
		// eine Schleife durch die Liste
		for (var s=0; s<pGroupIDs.length; s++) {
			// wenn die Position der Gruppe kleiner ist als jene des Formates
			// den zugehrigen Namen bernehmen
			if (pGroupIDs[s]<paraID) {
				grpName = pGroupNames[s];
				break;
			}
		}
		if (grpName != undefined) {
			// die Referenz mit 'paragraphStyleGroups' gilt nicht fr "[Root]"
			if (grpName != "[Root]") {
				var curGroup = app.documents[0].paragraphStyleGroups.item(grpName);
				var curPara = curGroup.paragraphStyles.item(curPara).properties = newProps;
			}
			else {
				app.documents[0].paragraphStyles.item(curPara).properties = newProps;
			}
		}
	}
}
// dasselbe mit einem gewhlten Zeichenstilformat
if (charID != 0) {
	var curChar = dlogCStyles[charID];
	if (nCSG == 0) {
		app.documents[0].characterStyles.item(curChar).properties = newProps;
	}
	else {
		grpName = undefined;
		curChar = curChar.slice(3);
		cGroupNames.reverse();
		for (var s=0; s<cGroupIDs.length; s++) {
			if (cGroupIDs[s]<charID) {
				grpName = cGroupNames[s];
				break;
			}
		}
		if (grpName != undefined) {
			if (grpName != "[Root]") {
				var curGroup = app.documents[0].characterStyleGroups.item(grpName);
				var curPara = curGroup.characterStyles.item(curChar).properties = newProps;
			}
			else {
				app.documents[0].characterStyles.item(curChar).properties = newProps;
			}
		}
	}
}